package com.autentia.tutoriales.spring.aop.aspectj;

import com.autentia.tutoriales.spring.aop.aspectj.cache.Cachea;
import com.autentia.tutoriales.spring.aop.aspectj.cache.Descachea;

/**
 * Bean de nuestra aplicación con métodos que cachean y descachean
 * @author Carlos García. Autentia.
 * @see http://www.mobiletest.es
 */
public class Provincias  {
	private java.util.List<String> provincias;
	
	/**
	 * Constructor
	 */
	public Provincias(){
		this.provincias = new java.util.ArrayList<String>();
	}
	
	/**
	 *(SIMULAMOS UNA OPERACION COSTOSA CACHEAMOS CON TIEMPO INFINITO)
	 * @return Devuelve todas las provincias 
	 */
	@Cachea(cacheKey="Provincias.provincias", expireTime=0)
	public java.util.List<String> getAll(){
		try {
			Thread.sleep(2000);
		} catch (InterruptedException e) {}
		
		return provincias;
	}
  	
	/**
	 * Añadimos una provincia (LIMPIAMOS LA CACHE)
	 * @param provincia Provincia a añadir
	 */
	@Descachea(cacheKey="Provincias.provincias")
	public void add(String provincia){
		provincias.add(provincia);
	}
}