package com.autentia.tutoriales.spring.aop.aspectj.cache;

import java.lang.annotation.*;

/**
 * Anotación para métodos que realizen operaciones de cacheo de información
 * @author Carlos García. Autentia.
 */
@Retention(RetentionPolicy.RUNTIME) 
@Target(ElementType.METHOD)
public @interface Cachea {
	/**
	 * @return Identificador dentro de la cache con la que se guardará la información
	 */
	public String cacheKey();
	
	/**
	 * @return Número de milisegundos que tendrá validez la cache
	 * (0=infinito la información se guarda en disco su cerramos la aplicación o 
	 * cuando se necesita "paginar" en base a la configuración de la cache)
	 */	
	public int expireTime();
}
